import { ClassTransformOptions } from 'class-transformer';
import { ColumnOptions, ColumnType } from 'typeorm';
import { ColumnMode } from 'typeorm/metadata-args/types/ColumnMode';
declare type ValueOf<T> = T[keyof T] | Date | number | string | boolean | null;
export declare class EntityPatcher {
    static patch<T>(EntityClass: new () => T, classTransformOptions?: ClassTransformOptions): T;
    static patchByMode<T>(mode: ColumnMode, options: ColumnOptions): ValueOf<T>;
    static patchValueByTypeormColumnOptions<T>(options: ColumnOptions): ValueOf<T> | null;
    static patchValueByTypeormColumnMode(mode: string): Date | null;
    static patchValueByTypeormColumnType<T>(typeormColumnTypeString: ColumnType): ValueOf<T>;
}
export {};
