"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.QueryBuilderStubber = void 0;
const typeorm_1 = require("typeorm");
class QueryBuilderStubber {
    _stubQueryBuilder(sandbox, stubs, stubRaws) {
        const queryBuilderStub = sandbox.createStubInstance(typeorm_1.SelectQueryBuilder);
        queryBuilderStub.select.returnsThis();
        queryBuilderStub.addSelect.returnsThis();
        queryBuilderStub.from.returnsThis();
        queryBuilderStub.addFrom.returnsThis();
        queryBuilderStub.where.returnsThis();
        queryBuilderStub.orWhere.returnsThis();
        queryBuilderStub.andWhere.returnsThis();
        queryBuilderStub.clone.returnsThis();
        queryBuilderStub.leftJoin.returnsThis();
        queryBuilderStub.leftJoinAndSelect.returnsThis();
        queryBuilderStub.leftJoinAndMapOne.returnsThis();
        queryBuilderStub.leftJoinAndMapMany.returnsThis();
        queryBuilderStub.orderBy.returnsThis();
        queryBuilderStub.addOrderBy.returnsThis();
        queryBuilderStub.skip.returnsThis();
        queryBuilderStub.take.returnsThis();
        queryBuilderStub.setParameter.returnsThis();
        queryBuilderStub.getOne.resolves(stubs[0]);
        queryBuilderStub.getOneOrFail.resolves(stubs[0]);
        queryBuilderStub.getMany.resolves(stubs);
        queryBuilderStub.getManyAndCount.resolves([stubs, stubs.length]);
        queryBuilderStub.getRawOne.resolves(stubRaws[0]);
        queryBuilderStub.getRawMany.resolves(stubRaws);
        queryBuilderStub.getRawAndEntities.resolves({
            entities: stubs,
            raw: stubRaws
        });
        const updateQueryBuilderStub = this._stubUpdateQueryBuilder(sandbox);
        queryBuilderStub.update.returns(updateQueryBuilderStub);
        return queryBuilderStub;
    }
    _stubUpdateQueryBuilder(sandbox) {
        const updateQueryBuilderStub = sandbox.createStubInstance(typeorm_1.UpdateQueryBuilder);
        updateQueryBuilderStub.set.returnsThis();
        updateQueryBuilderStub.where.returnsThis();
        updateQueryBuilderStub.andWhere.returnsThis();
        updateQueryBuilderStub.execute.resolves({ affected: 1 });
        return updateQueryBuilderStub;
    }
}
exports.QueryBuilderStubber = QueryBuilderStubber;

//# sourceMappingURL=query-builder-stubber.js.map
